> For the complete documentation index, see [llms.txt](https://docs.pentaho.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pentaho.com/pdia-data-integration/9.3-data-integration/pdi-transformation-steps-reference-overview/jms-consumer/before-you-begin-jms-consumer.md).

# Before you begin

Before using theJMS Consumer step, be aware of the following conditions:

* You must be familiar with JMS messaging to use this step. Additionally, you must have a message broker, such as Apache ActiveMQ or IBM MQ, available before you configure this step.
* This step supports JMS 2.0 and requires [Apache ActiveMQ Artemis](https://activemq.apache.org/artemis/).
* If you need to use JMS 1.1 with ActiveMQ or Artemis, use the previous versions of the JMS Consumer and JMS Producer steps, also available in Pentaho version 8.1 and earlier.
* Place IBM MQ client JARs for the IBM MQ middleware in the following directories:
  * On the PDI client: `data-integration/system/karaf/deploy`
  * On the Pentaho Server: `server/pentaho-server/pentaho-solutions/system/karaf/deploy`\
    You need to locate the WebSphere® MQ classes for JMS Java libraries from your IBM WebSphere® MQ installation. You can also find these libraries in your [IBM WebSphere MQ Client SupportPac](https://idaas.iam.ibm.com/idaas/mtfim/sps/authsvc?PolicyId=urn:ibm:security:authentication:asf:basicldapuser). The WebSphere® MQ Java libraries version that the PDI plugin steps were built against is 9.0.0.3. The libraries that you must have available for distribution into the PDI JMS plugin are:
  * `com.ibm.mq.osgi.allclientprereqs_9.0.0.3.jar`
  * `com.ibm.mq.osgi.allclient_9.0.0.3.jar`\
    Because IBM licensing prevents us from distributing these libraries directly, you will need to add them to your PDI directories.
* Place JMS Library jars for the **ConnectionFactory** and other supporting classes in the following directories:
  * On the PDI client: `data-integration/system/karaf/deploy`
  * On the Pentaho Server: `server/pentaho-server/pentaho-solutions/system/karaf/deploy`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pentaho.com/pdia-data-integration/9.3-data-integration/pdi-transformation-steps-reference-overview/jms-consumer/before-you-begin-jms-consumer.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
